"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "normalizeOptions", {
    enumerable: true,
    get: ()=>normalizeOptions
});
const _interopRequireDefault = require("@swc/helpers/lib/_interop_require_default.js").default;
const _lodashGet = /*#__PURE__*/ _interopRequireDefault(require("lodash.get"));
const _path = /*#__PURE__*/ _interopRequireDefault(require("path"));
const _constants = require("../constants");
const normalizeOptions = (options, compiler)=>{
    const { typescriptFolderName =_constants.TYPESCRIPT_FOLDER_NAME  } = options;
    const webpackCompilerOptions = compiler.options;
    const distPath = (0, _lodashGet.default)(webpackCompilerOptions, 'devServer.static.directory') || (0, _lodashGet.default)(webpackCompilerOptions, 'output.path') || 'dist';
    const distDir = _path.default.join(distPath, typescriptFolderName);
    const typesIndexJsonFilePath = _path.default.join(distDir, _constants.TYPES_INDEX_JSON_FILE_NAME);
    const tsCompilerOptions = {
        declaration: true,
        emitDeclarationOnly: true,
        outDir: _path.default.join(distDir, '/')
    };
    const webpackPublicPath = webpackCompilerOptions.output.publicPath;
    const publicPath = typeof webpackPublicPath === 'string' ? webpackPublicPath === 'auto' ? '' : webpackPublicPath : '';
    const remoteEntryFilename = options.federationConfig.filename;
    const typesStatsFileName = remoteEntryFilename ? remoteEntryFilename.replace('remoteEntry.js', _constants.TYPES_INDEX_JSON_FILE_NAME) : _constants.TYPES_INDEX_JSON_FILE_NAME;
    return {
        distDir,
        publicPath,
        tsCompilerOptions,
        typesIndexJsonFileName: _constants.TYPES_INDEX_JSON_FILE_NAME,
        typesIndexJsonFilePath,
        typesStatsFileName,
        typescriptFolderName,
        webpackCompilerOptions
    };
};

//# sourceMappingURL=normalizeOptions.js.map